
import "rushl.Horsey.ui";


HorseyBar = class( rushl.Horsey.ui.SimpleWindow );

function HorseyBar:Constructor()
	rushl.Horsey.ui.SimpleWindow.Constructor( self );
	
	self.spacing = 5;
	self.quickslotCount = 0;
	self.quickslotSize = 36;
	self.quickslots = { };
	self.quickslotInfo = { };
	
	self.numOfRows = 0;
	self.numOfCols = 0;   
	self.resizing = false;	
	
   self.lockStable = 0;	
	
	self.menuButton = Turbine.UI.Control()
	self.menuButton:SetParent( self );
	self.menuButton:SetBackground( "rushl/Horsey3/Resources/DownArrow.tga" );
	self.menuButton:SetSize( 14, 13 );
	
	self.stableLockButton = Turbine.UI.Control();
   self.stableLockButton:SetParent( self );
	
	
	self.menuButton.MouseDown = function( sender, args )
		local contextMenu = Turbine.UI.ContextMenu()
		
		local sizeCols = Turbine.UI.MenuItem( "Columns" );
		local sizeColsItems = sizeCols:GetItems();
		
      local sizeRows = Turbine.UI.MenuItem( "Rows" );
      local sizeRowsItems = sizeRows:GetItems();		
		
		-- loop to set selected number of rows
		local i;
		for i = 1, 10, 1 do
			local rowItem = Turbine.UI.MenuItem( tostring( i ) );
			
			if ( self.numOfRows == i ) then
				rowItem:SetChecked( true );
			end
		
			rowItem.Click = function( sender, args )			
	         self.resizing = true;
				local newCount = tonumber( sender:GetText() );
				self.numOfRows = newCount;
				self:SetQuickslotCount( self.numOfRows * self.numOfCols );
				self.settings.numOfRows = newCount;
				QuickslotCountSave = self.settings.QuickslotCount
				self:SaveSettings();
				self.resizing = false;
			end
			
			sizeRowsItems:Add( rowItem );
		end
		
	   -- loop to set selected number of columns
		local i;		
		for i = 1, 30, 1 do
			local colItem = Turbine.UI.MenuItem( tostring( i ) );
			
			if ( self.numOfCols == i ) then
				colItem:SetChecked( true );
			end
			
			colItem.Click = function( sender, args )			
	         self.resizing = true;
				local newCount = tonumber( sender:GetText() );
				self.numOfCols = newCount;
				self:SetQuickslotCount( self.numOfRows * self.numOfCols );
				self.settings.numOfCols = newCount;
				QuickslotCountSave = self.settings.QuickslotCount
				self:SaveSettings();
	         self.resizing = false;
			end
			
			sizeColsItems:Add( colItem );
		end
		
		local contextMenuItems = contextMenu:GetItems();
		contextMenuItems:Add( sizeRows ); 
		contextMenuItems:Add( sizeCols );
		contextMenu:ShowMenu();
	end
	
   -- load settings and set up quickslots
	self:LoadSettings();
	self:SetQuickslotCount( self.numOfRows * self.numOfCols );
	
   	-- couple of variables to track hidden state 
	self:SetWantsKeyEvents(true);
   self.currentVisState = self:IsVisible();
   self.hidden = false;	
	
	self:SetVisible( true );
	self:SetOpacity( 1 );
	self:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );
	
	   -- manage hiding the UI
   self.KeyDown = function( sender, args)
      if(args.Action == 268435635) then
         if(self.hidden == false) then
             self.currentVisState = self:IsVisible();
             self.hidden = true;
             self:SetVisible(false);
         else
             self.hidden = false;
             self:SetVisible(self.currentVisState);
         end
      else
         --Turbine.Shell.WriteLine(args.Action);
      end
   end	
   
   -- handle locking the stable the   
   
   if(self.lockStable == 1) then
      self.stableLockButton:SetSize( 17, 20 );
      self.stableLockButton:SetBackground("rushl/Horsey3/Resources/chargen_appearance_lock.tga" ); 
   else
      self.stableLockButton:SetSize( 20, 20 );  
      self.stableLockButton:SetBackground("rushl/Horsey3/Resources/button_lock_normal_normal.tga" ); 
   end 
   
   
   self.stableLockButton.MouseDown = function( sender, args )  
      if(self.lockStable == 1) then
         self.lockStable = 0;
         self.stableLockButton:SetSize( 20, 20 );
         self.stableLockButton:SetBackground("rushl/Horsey3/Resources/button_lock_normal_normal.tga" );  
      else
         self.lockStable = 1;
         self.stableLockButton:SetSize( 17, 20 );
         self.stableLockButton:SetBackground("rushl/Horsey3/Resources/chargen_appearance_lock.tga" );  
      end
		self:SaveSettings();	          
   end	
end
	
function HorseyBar:IsLocked()
   return self.lockStable;
end

function HorseyBar:LoadSettings()
	self.settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "Horsey3BarSettings" );

	if ( type( self.settings ) ~= "table" ) then
		self.settings = { };
	end

	if ( not self.settings.QuickslotCount or self.settings.QuickslotCount == "nil" ) then
		self.settings.QuickslotCount = tostring(5);
	end
	
	if ( not self.settings.positionX or self.settings.positionX == "nil" ) then
		self.settings.positionX = tostring(500);
	end
	
	if ( not self.settings.positionY or self.settings.positionY == "nil" ) then
		self.settings.positionY = tostring(500);
	end
	
	if (not self.settings.numOfRows or self.settings.numOfRows == "nil" ) then
	  self.settings.numOfRows = tostring(1);
	end
	
	if (not self.settings.numOfCols or self.settings.numOfCols == "nil" ) then
	  self.settings.numOfCols = tostring(5);
	end
	
	if (not self.settings.lockStable or self.settings.lockStable == "nil") then
	  self.settings.lockStable = tostring(0);
	end
	
	if(type( self.settings.numOfRows ) == "string" ) then
	   self.numOfRows = tonumber(self.settings.numOfRows);
	else
	   self.numOfRows = self.settings.numOfRows;
   end

	if(type( self.settings.numOfCols ) == "string" ) then
	   self.numOfCols = tonumber(self.settings.numOfCols);
	else
	   self.numOfCols = self.settings.numOfCols;
   end
	
	if(type( self.settings.positionX ) == "string" ) then
	   FirebarpositionX = tonumber(self.settings.positionX);
	else
	FirebarpositionX = self.settings.positionX;
   end

	if(type( self.settings.positionY ) == "string" ) then
	   FirebarpositionY = tonumber(self.settings.positionY);
	else
	FirebarpositionY = self.settings.positionY;
   end	
	
   if(type( self.settings.lockStable ) == "string" ) then
      self.lockStable = tonumber(self.settings.lockStable);
   else
      self.lockStable = self.settings.lockStable;
   end	
	
	QuickslotCountSave = self.numOfCols * self.numOfRows;	
	
	
	-- load the mount information
	self.quickslotInfoTemp = Turbine.PluginData.Load( Turbine.DataScope.Character, "Horsey3" );

	if ( type( self.quickslotInfoTemp ) ~= "table" ) then
		self.quickslotInfoTemp = { };
	end	

		self.quickslotInfo = { };
   local doOnce = true;
   for i,v in pairs(self.quickslotInfoTemp) do     
      if(type(i) == "number") then
            if(doOnce == true) then
               self.quickslotInfo["0"] = self.quickslotInfoTemp[0];
               --self.quickslotInfo[0] = nil;
               doOnce = false;
            end 
            self.quickslotInfo[tostring(i)] = v;
            --self.quickslotInfo[i] = nil;
      else
         self.quickslotInfo[i] = v;
      end                                
	end

   --Turbine.Shell.WriteLine("There are " .. tablelength(self.quickslotInfo) .. " quickslots");    
end
	
function tablelength(T) 
  local count = 0 
  for _ in pairs(T) do count = count + 1 end 
  return count 
end

function HorseyBar:SaveSettings()
	self.settings = { };
	self.settings.QuickslotCount = tostring(QuickslotCountSave);
	self.settings.positionX = tostring(FirebarpositionX);
	self.settings.positionY = tostring(FirebarpositionY);
	self.settings.numOfRows = tostring(self.numOfRows);
	self.settings.numOfCols = tostring(self.numOfCols);
	self.settings.lockStable = tostring(self.lockStable);
	
	Turbine.PluginData.Save( Turbine.DataScope.Character, "Horsey3BarSettings", self.settings );
end

function HorseyBar:FireWindow()
   self:FireBar();
end

function HorseyBar:SetQuickslotCount( value )
	local i;
	self.quickslotCount = value;

	-- Set quickslot change handler	
	local function OnQuickslotChanged( sender, args )
	
	  if(self.resizing == true) then
	     return;
	end
	
      --Turbine.Shell.WriteLine("There are " .. tablelength(self.quickslotInfo) .. " quickslots before."); 
		local shortcut = sender:GetShortcut();

		if ( shortcut ~= nil ) then
         --Turbine.Shell.WriteLine("There is a shortcut");		
         if((shortcut:GetType() == nil) or (shortcut:GetData() == nil) or shortcut:GetType() == 0) then
            --Turbine.Shell.WriteLine("But the data is bad");
			   self.quickslotInfo[tostring(sender.Index)] = nil;
			else
            --Turbine.Shell.WriteLine("Type: " .. shortcut:GetType() .. " and Data: " .. shortcut:GetData());		
			   self.quickslotInfo[tostring(sender.Index)] = { };
			   self.quickslotInfo[tostring(sender.Index)].Type = shortcut:GetType();
			   self.quickslotInfo[tostring(sender.Index)].Data= shortcut:GetData();
         end

		else
		   --Turbine.Shell.WriteLine("There is no shortcut");
			self.quickslotInfo[tostring(sender.Index)] = nil;
		end

		if ( self.loading ) then
			return;
		end

      -- convert quickslot info to strings
      for i,v in pairs(self.quickslotInfo) do
         if(type(v.Type) == "number") then
            v.Type = tostring(v.Type);
         end
      end   
      
      -- remove any non-string indexed entries
      for counter = 0, 300, i do
         self.quickslotInfo[counter] = nil;    
      end       

		-- Request for the quickslot info table to be saved.
      --Turbine.Shell.WriteLine("There are " .. tablelength(self.quickslotInfo) .. " quickslots after.");       
		Turbine.PluginData.Save( Turbine.DataScope.Character, "Horsey3", self.quickslotInfo );
	end
	
	if(self.resizing == true) then
	   for a = 0, 300, 1 do
	      if(self.quickslots[a] ~= nil) then
	         self.quickslots[a]:SetShortcut(nil);
	         self.quickslots[a]:SetParent(nil);
	         self.quickslots[a] = nil;	      
	      end
	   end
	   
	   self.quickslots = { };
	end
   
	-- clean up any unused quickslots
	for a = 0, 300, 1 do
	   if(self.quickslots[a] ~= nil) then

	      --Turbine.Shell.WriteLine("Shortcut " .. a .. " is available");
	      local tempShortcut = self.quickslots[a]:GetShortcut();
	      
	      if(tempShortcut ~= nil) then	      
            --if(self.resizing == true) then
               --self.quickslots[a]:SetShortcut(nil);
	            --self.quickslots[a]:SetParent(nil);
				   --self.quickslots[a] = nil;	      
	         --end
	         if(tempShortcut:GetType() ~= nil and tempShortcut:GetType() == 0) then
	           --Turbine.Shell.WriteLine("Index " .. a .. " is type: " .. tempShortcut:GetType());
	           self.quickslots[a]:SetShortcut(nil);
	           self.quickslots[a]:SetParent(nil);
				  self.quickslots[a] = nil;
	         end
	      end
	   end
	end
		
	-- Add quickslots that should be created.
	for k = 0, self.numOfRows - 1, 1 do
	   for j = 0, self.numOfCols - 1, 1 do

	      i = (k * self.numOfCols) + j;	      

		   self.quickslots[i] = Turbine.UI.Lotro.Quickslot();
		   --self.quickslots[i]:SetParent( self );
		   --self.quickslots[i]:SetSize( self.quickslotSize, self.quickslotSize );		   
		   --self.quickslots[i]:SetPosition( j * (self.quickslotSize + self.spacing ), k * ( self.quickslotSize + self.spacing ));
		   --self.quickslots[i].Index = i;

		   local quickslotInfoT = self.quickslotInfo[tostring(i)];  

         -- set the shortcut in the quickslot
		   if ( quickslotInfoT ~= nil ) then
	         self:createEmptyQuickslot(i, j * (self.quickslotSize + self.spacing ), k * ( self.quickslotSize + self.spacing ));
			   local shortcut = Turbine.UI.Lotro.Shortcut( 6, quickslotInfoT.Data );
			self.quickslots[i]:SetShortcut( shortcut );
			self.quickslots[i]:SetVisible( true );
			   self.quickslots[i]:SetUseOnRightClick(false);
		      self.quickslots[i].ShortcutChanged = OnQuickslotChanged;
			else
	         self:createEmptyQuickslot(i, j * (self.quickslotSize + self.spacing ), k * ( self.quickslotSize + self.spacing ));
		      self.quickslots[i].ShortcutChanged = OnQuickslotChanged;
            --self.quickslots[i]:SetShortcut(nil);		
		end
		
		--Give a way to remove a filled slot
			self.quickslots[i].MouseClick = function( sender, args )
				if(args.Button == Turbine.UI.MouseButton.Right and self.lockStable ~= 1) then
				   local x,y = self.quickslots[sender.Index]:GetPosition();
					self.quickslots[sender.Index]:SetShortcut( nil );
					self.quickslots[sender.Index] = nil;
					self:createEmptyQuickslot(sender.Index,x,y);
					self.quickslots[sender.Index].ShortcutChanged = OnQuickslotChanged;
						end
			   HorseyWindow:SetVisible( false );
					end
		end		
	end

	local displayWidth = Turbine.UI.Display:GetWidth();
	local displayHeight = Turbine.UI.Display:GetHeight();

	local width = self.numOfCols * self.quickslotSize + ( self.numOfCols * self.spacing ) + 20;
	local height = self.numOfRows * self.quickslotSize + ( self.numOfRows * self.spacing );
	
	self:SetSize( width, height );
	self:SetPosition( ( displayWidth - width ) / 2, displayHeight * 1 / 2 );

   self.menuButton:SetPosition( width - 16, 1); 
   self.stableLockButton:SetPosition( width - 20, 17); 	
end

function HorseyBar:createEmptyQuickslot(index,x,y)

		   self.quickslots[index] = Turbine.UI.Lotro.Quickslot();
		   self.quickslots[index]:SetParent( self );
		   self.quickslots[index]:SetSize( self.quickslotSize, self.quickslotSize );		   
		   self.quickslots[index]:SetPosition(x,y);
		   self.quickslots[index].Index = index;
			self.quickslots[index]:SetUseOnRightClick(false);
		   self.quickslots[index].ShortcutChanged = OnQuickslotChanged;
	
		   		   --Give a way to remove a filled slot
			self.quickslots[index].MouseClick = function( sender, args )
				if(args.Button == Turbine.UI.MouseButton.Right and self.lockStable ~= 1) then
				  local x,y = self.quickslots[sender.Index]:GetPosition();
					self.quickslots[sender.Index]:SetShortcut( nil );
					self.quickslots[sender.Index] = nil;
					self:createEmptyQuickslot(sender.Index,x,y);
				end
				HorseyWindow:SetVisible( false );
			end
end

	-- create the launcher window
function HorseyBar:FireBar()

	self.positionX = FirebarpositionX;
	self.positionY = FirebarpositionY;	
	
	FireWindow = Turbine.UI.Lotro.Window();
	FireWindow:SetWidth(151);
	FireWindow:SetPosition( self.positionX, self.positionY);
	FireWindow:SetText("Horsey3!");
	FireQuickslot = Turbine.UI.Lotro.Quickslot();
	FireQuickslot:SetParent(FireWindow);
	FireQuickslot:SetSize(36, 36);
	FireQuickslot:SetPosition(60, 40);
	FireWindow:SetVisible( true );
	
	FireQuickslot.MouseClick = function( sender, args )
    FireWindow:SetVisible( false );
	end
	
	-- couple of variables to track hidden state 
	FireWindow:SetWantsKeyEvents(true);
   FireWindow.currentVisState = FireWindow:IsVisible();
   FireWindow.hidden = false;	
		
	-- manage hiding the UI
   FireWindow.KeyDown = function( sender, args)
      if(args.Action == 268435635) then
         if(FireWindow.hidden == false) then
             FireWindow.currentVisState = FireWindow:IsVisible();
             FireWindow.hidden = true;
             FireWindow:SetVisible(false);
         else
             FireWindow.hidden = false;
             FireWindow:SetVisible(FireWindow.currentVisState);
         end
      else
         --Turbine.Shell.WriteLine(args.Action);
      end
   end
	
	
	--Figure out how many slots are filled
	local MaxRand = tablelength(self.quickslotInfo);
	local i;
	local failsafe = 0
	
		-- Take out check value	
	--Turbine.Shell.WriteLine("Count:".. MaxRand);
	
	--Assign one to the Fire Window
	repeat
	i = math.random(0, MaxRand);
	
			--Turbine.Shell.WriteLine("Random: ".. i)
	local quickslotInfoT = self.quickslotInfo[tostring(i)];	
			
	if ( quickslotInfoT ~= nil ) then	         
		local checktype = self.quickslotInfo[tostring(i)].Type
	
		--Turbine.Shell.WriteLine("incoming type: ".. checktype)
		
			if (checktype == "6" or checktype == 6) then
				-- Take out check value
				--Turbine.Shell.WriteLine("Assigned: ".. i)
				--Turbine.Shell.WriteLine("incoming type: ".. checktype)
			
				local shortcut = Turbine.UI.Lotro.Shortcut( tonumber(self.quickslotInfo[tostring(i)].Type), self.quickslotInfo[tostring(i)].Data );
								
				FireQuickslot:SetShortcut( shortcut );
	         FireQuickslot:SetParent(FireWindow);
				FireQuickslot:SetVisible(true);			
				checksuccess = true;
			else
				--Turbine.Shell.WriteLine("skipped");
				checksuccess = false;
			end
	
	else
		--Turbine.Shell.WriteLine("blank");
		checksuccess = false;
		
	end
	
	failsafe = failsafe + 1;
		-- Take out check value
		--Turbine.Shell.WriteLine("Failsafe: ".. failsafe)
	
	until failsafe == 100 or checksuccess == true;

	
	
	FireWindow.PositionChanged = function( sender, args )
		local x,y = FireWindow:GetPosition();
		FirebarpositionX = x;
		FirebarpositionY = y;
		
		--Turbine.Shell.WriteLine(FirebarpositionX.." x "..FirebarpositionY);
		--HorseyBar:SaveSettings();
		self:SaveSettings();
	end
	
	--old test code
	
	--Turbine.Shell.WriteLine( self.quickslotInfo[3].Type.." ".. self.quickslotInfo[3].Data )
	--Turbine.Shell.WriteLine("Count:".. self.quickslotCount);
end







